/*
  CTextureJPG - uses libjpeg
  Created: 20/05/1999
  Author : Sylvain Lefebvre
*/
//---------------------------------------------------------------------------
#include "CTextureJPG.h"
#include "CException.h"
//---------------------------------------------------------------------------
/*
  LibJPEG stuff
 */
//---------------------------------------------------------------------------
#include <iostream>
#include <cstdio>
#include <cstring>
#  ifdef __cplusplus
   extern "C" {
#  endif
#include "jpeglib.h"
#  ifdef __cplusplus
   }
#  endif
#include <setjmp.h>
//---------------------------------------------------------------------------
CTextureJPG::CTextureJPG(const char *n) : CTexture()
{
  strcpy(m_szName,n);
  CTextureJPG::load();
}
//---------------------------------------------------------------------------
void CTextureJPG::load()
{
  /* on charge le JPG */
  struct jpeg_decompress_struct cinfo;
  struct jpeg_error_mgr jerr;
  FILE * infile;		/* source file */
  JSAMPARRAY buffer;		/* Output row buffer */
  int row_stride;		/* physical row width in output buffer */
  int i,line=0;
  unsigned char *pbmp;

  if (m_bLoaded)
    return;
  m_iWidth=0;
  m_iHeight=0;
  m_Data=NULL;
  

  if ((infile = fopen(m_szName, "rb")) == NULL)
    throw CException(true,"Unable to load %s",m_szName);
  cinfo.err = jpeg_std_error(&jerr);
  jpeg_create_decompress(&cinfo);
  jpeg_stdio_src(&cinfo, infile);
  (void) jpeg_read_header(&cinfo, TRUE);
  (void) jpeg_start_decompress(&cinfo);


  m_iWidth=cinfo.output_width;
  m_iHeight=cinfo.output_height;
  //  std::cerr << "Loading JPG image " << m_szName << " " << m_iWidth << "x" << m_iHeight 
  //       << std::endl;
  row_stride = cinfo.output_width * cinfo.output_components;
  m_iStride=row_stride;
  buffer = (*cinfo.mem->alloc_sarray)
  		((j_common_ptr) &cinfo, JPOOL_IMAGE, row_stride, 1);
  m_Data=new unsigned char[cinfo.output_height*row_stride];
  line=0;
  while (cinfo.output_scanline < cinfo.output_height)
  {
    (void) jpeg_read_scanlines(&cinfo, buffer, 1);
    pbmp = (unsigned char *)(m_Data+row_stride*line);
    line++;
    for (i=0;i<row_stride/3;i++)
    {
      pbmp[i*3] = buffer[0][i*3];
      pbmp[i*3+1] = buffer[0][i*3+1];
      pbmp[i*3+2] = buffer[0][i*3+2];
    }
  }
  (void) jpeg_finish_decompress(&cinfo);
  jpeg_destroy_decompress(&cinfo);
  fclose(infile);
  if (m_Data)
    m_bLoaded=true;
}
//---------------------------------------------------------------------------
