# little config script used by qmake  

unix{

	MOBINET_DIR = $$system(pwd)

 	macx {
		EXTLIB_PATH =  $$MOBINET_DIR/lib/OS-X
		INCLUDEPATH += /sw/include
		INCLUDEPATH += $$MOBINET_DIR/lib/include
    
		QMAKE_MACOSX_DEPLOYMENT_TARGET=10.5
	}
	else{ #  LINUX configuration

		# uncomment the next line if you want to compile with packaging configuration (just defines the default mobiles and presets directories)
		#DEFINES += LINUX_PACKAGE_INSTALL

		EXTLIB_PATH =  $$MOBINET_DIR/lib/linux
	}

}


win32{

	MOBINET_DIR = $$system(echo %CD%)

	win32-msvc.net : 	EXTLIB_PATH =  $$MOBINET_DIR/lib/win32/VC7
	win32-msvc2005 : 	EXTLIB_PATH =  $$MOBINET_DIR/lib/win32/VC8
	win32-msvc2008 : 	EXTLIB_PATH =  $$MOBINET_DIR/lib/win32/VC8

	CONFIG += console vc7 thread
  	contains (CONFIGDEBUG, debug) {
  		QMAKE_LFLAGS += /NODEFAULTLIB:libcd /NODEFAULTLIB:MSVCRT
  	}
  	contains (CONFIGDEBUG, release) {
		QMAKE_LFLAGS += /NODEFAULTLIB:libc /NODEFAULTLIB:MSVCRTD
  	}


  	# Config for Visual C++ 7
  	win32-msvc.net{
  		QMAKE_CXXFLAGS_DEBUG = -wd4675 -wd4250 -GR -GX -MDd 
		QMAKE_CXXFLAGS_RELEASE = -wd4675 -wd4250 -GR -GX -Ox -Og -Ob2 -GA -Ot -MD
		DEFINES += VC7
  	}
	
  	# Config for Visual C++ 8
  	win32-msvc2005{
		QMAKE_CXXFLAGS_DEBUG = -wd4996 -wd4250 -GR -EHsc -MDd  -Od -ZI -Gm
		QMAKE_CXXFLAGS_RELEASE = -wd4996 -wd4250 -GR -EHsc -Ox -Og -Ob2 -GA -Ot -MD
		DEFINES += VC8
	}
	# Config for Visual C++ 9
	win32-msvc2008{
		QMAKE_CXXFLAGS_DEBUG = -wd4996 -wd4250 -GR -EHsc -MDd  -Od -ZI -Gm
		QMAKE_CXXFLAGS_RELEASE = -wd4996 -wd4250 -GR -EHsc -Ox -Og -Ob2 -GA -Ot -MD
		DEFINES += VC9
	}

}


# here you can specify the path to the external libs
	ANTLR_INC_PATH		=	$$MOBINET_DIR/lib/include/antlr-2.7
  	ANTLR_LIB_PATH		=	$$EXTLIB_PATH
	XML2_INC_PATH		=	$$MOBINET_DIR/lib/include/libxml2
	XML2_LIB_PATH		=	$$EXTLIB_PATH
	SDL_INC_PATH		=	$$MOBINET_DIR/lib/include/sdl
	SDL_LIB_PATH		=	$$EXTLIB_PATH
 	JPEG_INC_PATH		=	$$MOBINET_DIR/lib/include/libjpeg
  	JPEG_LIB_PATH		=	$$EXTLIB_PATH
 	QGLVIEWER_INC_PATH	=	$$MOBINET_DIR/lib/include/libQGLViewer
 	QGLVIEWER_LIB_PATH	=	$$EXTLIB_PATH
 	ICONV_INC_PATH		=	$$MOBINET_DIR/lib/include
 	ICONV_LIB_PATH		=	$$EXTLIB_PATH
 
  	OBJECTS_DIR = OBJ

